/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20190509 (64-bit version)
 * Copyright (c) 2000 - 2019 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of ssdt6.dat, Fri Mar 25 12:02:59 2022
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000CCD (3277)
 *     Revision         0x01
 *     Checksum         0xB8
 *     OEM ID           "INSYDE"
 *     OEM Table ID     "CNL-ULT"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "ACPI"
 *     Compiler Version 0x00040000 (262144)
 */
DefinitionBlock ("", "SSDT", 1, "INSYDE", "CNL-ULT", 0x00001000)
{
    External (_SB_.PCI0.LPCB, DeviceObj)
    External (KBWK, UnknownObj)
    External (MSWK, UnknownObj)

    Scope (\_SB.PCI0.LPCB)
    {
        Device (SIOX)
        {
            Name (_HID, EisaId ("PNP0A05") /* Generic Container Device */)  // _HID: Hardware ID
            Name (_UID, "SModule")  // _UID: Unique ID
            Name (SIDP, 0x2E)
            Method (_STA, 0, Serialized)  // _STA: Status
            {
                Return (0x0F)
            }

            OperationRegion (OFST, SystemIO, SIDP, 0x02)
            Field (OFST, ByteAcc, NoLock, Preserve)
            {
                INDX,   8, 
                DATA,   8
            }

            IndexField (INDX, DATA, ByteAcc, NoLock, Preserve)
            {
                Offset (0x07), 
                CR07,   8, 
                Offset (0x22), 
                CR22,   8, 
                Offset (0x2D), 
                CR2D,   8, 
                Offset (0x30), 
                CR30,   8, 
                Offset (0x60), 
                CR60,   8, 
                CR61,   8, 
                Offset (0x70), 
                CR70,   8, 
                Offset (0x72), 
                CR72,   8, 
                Offset (0x74), 
                CR74,   8, 
                Offset (0xC0), 
                CRC0,   8, 
                Offset (0xE0), 
                CRE0,   8, 
                CRE1,   8, 
                CRE2,   8, 
                CRE3,   8, 
                CRE4,   8, 
                CRE5,   8, 
                CRE6,   8, 
                CRE7,   8, 
                Offset (0xEB), 
                CREB,   8, 
                CREC,   8, 
                Offset (0xF0), 
                CRF0,   8, 
                CRF1,   8, 
                CRF2,   8, 
                CRF3,   8, 
                CRF4,   8, 
                CRF5,   8, 
                CRF6,   8, 
                CRF7,   8, 
                CRF8,   8, 
                CRF9,   8
            }

            OperationRegion (LGDN, SystemMemory, 0x7BB00F18, 0x00000028)
            Field (LGDN, AnyAcc, Lock, Preserve)
            {
                ADVC,   8, 
                ABIO,   16, 
                ALDN,   8, 
                BDVC,   8, 
                BBIO,   16, 
                BLDN,   8, 
                CDVC,   8, 
                CBIO,   16, 
                CLDN,   8, 
                DDVC,   8, 
                DBIO,   16, 
                DLDN,   8, 
                EDVC,   8, 
                EBIO,   16, 
                ELDN,   8, 
                FDVC,   8, 
                FBIO,   16, 
                FLDN,   8, 
                HDVC,   8, 
                HBIO,   16, 
                HLDN,   8, 
                IDVC,   8, 
                IBIO,   16, 
                ILDN,   8, 
                JDVC,   8, 
                JBIO,   16, 
                JLDN,   8, 
                LDVC,   8, 
                LBIO,   16, 
                LLDN,   8
            }

            Method (ENCG, 0, NotSerialized)
            {
                If ((SIDP == 0x2E))
                {
                    INDX = 0x87
                    INDX = One
                    INDX = 0x55
                    INDX = 0x55
                }
                Else
                {
                    INDX = 0x87
                    INDX = One
                    INDX = 0x55
                    INDX = 0xAA
                }
            }

            Method (EXCG, 0, NotSerialized)
            {
                INDX = 0x02
                DATA = 0x02
            }

            Device (UAR1)
            {
                Name (_HID, EisaId ("PNP0501") /* 16550A-compatible COM Serial Port */)  // _HID: Hardware ID
                Name (_UID, "SModuleC1")  // _UID: Unique ID
                Name (_DDN, "COM1      ")  // _DDN: DOS Device Name
                Method (_STA, 0, NotSerialized)  // _STA: Status
                {
                    ENCG ()
                    CR07 = One
                    Local0 = Zero
                    If (ADVC)
                    {
                        Local0 = 0x0D
                        If (CR30)
                        {
                            Local0 = 0x0F
                        }
                    }

                    EXCG ()
                    Return (Local0)
                }

                Method (_DIS, 0, NotSerialized)  // _DIS: Disable Device
                {
                    ENCG ()
                    CR07 = One
                    Local0 = (CRF0 & 0xF9)
                    CRF0 = Local0
                    CR30 = Zero
                    EXCG ()
                }

                Method (_CRS, 0, NotSerialized)  // _CRS: Current Resource Settings
                {
                    Name (C1CR, Zero)
                    Name (BUF0, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x03F8,             // Range Minimum
                            0x03F8,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            _Y00)
                        IRQ (Edge, ActiveHigh, Exclusive, _Y01)
                            {4}
                    })
                    CreateByteField (BUF0, \_SB.PCI0.LPCB.SIOX.UAR1._CRS._Y00._MIN, IOLO)  // _MIN: Minimum Base Address
                    CreateByteField (BUF0, 0x03, IOHI)
                    CreateByteField (BUF0, \_SB.PCI0.LPCB.SIOX.UAR1._CRS._Y00._MAX, IORL)  // _MAX: Maximum Base Address
                    CreateByteField (BUF0, 0x05, IORH)
                    CreateWordField (BUF0, \_SB.PCI0.LPCB.SIOX.UAR1._CRS._Y01._INT, IRQL)  // _INT: Interrupts
                    ENCG ()
                    CR07 = One
                    IOLO = CR61 /* \_SB_.PCI0.LPCB.SIOX.CR61 */
                    IORL = CR61 /* \_SB_.PCI0.LPCB.SIOX.CR61 */
                    IOHI = CR60 /* \_SB_.PCI0.LPCB.SIOX.CR60 */
                    IORH = CR60 /* \_SB_.PCI0.LPCB.SIOX.CR60 */
                    Local0 = One
                    IRQL = (Local0 << CR70) /* \_SB_.PCI0.LPCB.SIOX.CR70 */
                    EXCG ()
                    Return (BUF0) /* \_SB_.PCI0.LPCB.SIOX.UAR1._CRS.BUF0 */
                }

                Method (_PRS, 0, NotSerialized)  // _PRS: Possible Resource Settings
                {
                }

                Method (_SRS, 1, NotSerialized)  // _SRS: Set Resource Settings
                {
                    CreateByteField (Arg0, 0x02, IOLO)
                    CreateByteField (Arg0, 0x03, IOHI)
                    CreateWordField (Arg0, 0x09, IRQL)
                    ENCG ()
                    CR07 = One
                    CR61 = IOLO /* \_SB_.PCI0.LPCB.SIOX.UAR1._SRS.IOLO */
                    CR60 = IOHI /* \_SB_.PCI0.LPCB.SIOX.UAR1._SRS.IOHI */
                    FindSetRightBit (IRQL, CR70) /* \_SB_.PCI0.LPCB.SIOX.CR70 */
                    If ((IRQL != Zero))
                    {
                        CR70--
                    }

                    CR30 = One
                    If ((ALDN == One))
                    {
                        Local0 = (CRF0 | 0x06)
                        CRF0 = Local0
                    }

                    EXCG ()
                }
            }

            Device (UAR2)
            {
                Name (_HID, EisaId ("PNP0501") /* 16550A-compatible COM Serial Port */)  // _HID: Hardware ID
                Name (_UID, "SModuleC2")  // _UID: Unique ID
                Name (_DDN, "COM2      ")  // _DDN: DOS Device Name
                Method (_STA, 0, NotSerialized)  // _STA: Status
                {
                    ENCG ()
                    CR07 = 0x02
                    Local0 = Zero
                    If (BDVC)
                    {
                        Local0 = 0x0D
                        If (CR30)
                        {
                            Local0 = 0x0F
                        }
                    }

                    EXCG ()
                    Return (Local0)
                }

                Method (_DIS, 0, NotSerialized)  // _DIS: Disable Device
                {
                    ENCG ()
                    CR07 = 0x02
                    Local0 = (CRF0 & 0xF9)
                    CRF0 = Local0
                    CR30 = Zero
                    EXCG ()
                }

                Method (_CRS, 0, NotSerialized)  // _CRS: Current Resource Settings
                {
                    Name (C2CR, Zero)
                    Name (BUF0, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x02F8,             // Range Minimum
                            0x02F8,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            _Y02)
                        IRQ (Edge, ActiveHigh, Exclusive, _Y03)
                            {3}
                    })
                    CreateByteField (BUF0, \_SB.PCI0.LPCB.SIOX.UAR2._CRS._Y02._MIN, IOLO)  // _MIN: Minimum Base Address
                    CreateByteField (BUF0, 0x03, IOHI)
                    CreateByteField (BUF0, \_SB.PCI0.LPCB.SIOX.UAR2._CRS._Y02._MAX, IORL)  // _MAX: Maximum Base Address
                    CreateByteField (BUF0, 0x05, IORH)
                    CreateWordField (BUF0, \_SB.PCI0.LPCB.SIOX.UAR2._CRS._Y03._INT, IRQL)  // _INT: Interrupts
                    ENCG ()
                    CR07 = 0x02
                    IOLO = CR61 /* \_SB_.PCI0.LPCB.SIOX.CR61 */
                    IORL = CR61 /* \_SB_.PCI0.LPCB.SIOX.CR61 */
                    IOHI = CR60 /* \_SB_.PCI0.LPCB.SIOX.CR60 */
                    IORH = CR60 /* \_SB_.PCI0.LPCB.SIOX.CR60 */
                    Local0 = One
                    IRQL = (Local0 << CR70) /* \_SB_.PCI0.LPCB.SIOX.CR70 */
                    EXCG ()
                    Return (BUF0) /* \_SB_.PCI0.LPCB.SIOX.UAR2._CRS.BUF0 */
                }

                Method (_PRS, 0, NotSerialized)  // _PRS: Possible Resource Settings
                {
                }

                Method (_SRS, 1, NotSerialized)  // _SRS: Set Resource Settings
                {
                    CreateByteField (Arg0, 0x02, IOLO)
                    CreateByteField (Arg0, 0x03, IOHI)
                    CreateWordField (Arg0, 0x09, IRQL)
                    ENCG ()
                    CR07 = 0x02
                    CR61 = IOLO /* \_SB_.PCI0.LPCB.SIOX.UAR2._SRS.IOLO */
                    CR60 = IOHI /* \_SB_.PCI0.LPCB.SIOX.UAR2._SRS.IOHI */
                    FindSetRightBit (IRQL, CR70) /* \_SB_.PCI0.LPCB.SIOX.CR70 */
                    If ((IRQL != Zero))
                    {
                        CR70--
                    }

                    CR30 = One
                    If ((BLDN == One))
                    {
                        Local0 = (CRF0 | 0x06)
                        CRF0 = Local0
                    }

                    EXCG ()
                }
            }

            Device (UAR3)
            {
                Name (_HID, EisaId ("PNP0501") /* 16550A-compatible COM Serial Port */)  // _HID: Hardware ID
                Name (_UID, "SModuleC3")  // _UID: Unique ID
                Name (_DDN, "COM3      ")  // _DDN: DOS Device Name
                Method (_STA, 0, NotSerialized)  // _STA: Status
                {
                    ENCG ()
                    CR07 = 0x08
                    Local0 = Zero
                    If (CDVC)
                    {
                        Local0 = 0x0D
                        If (CR30)
                        {
                            Local0 = 0x0F
                        }
                    }

                    EXCG ()
                    Return (Local0)
                }

                Method (_DIS, 0, NotSerialized)  // _DIS: Disable Device
                {
                    ENCG ()
                    CR07 = 0x08
                    CRF0 = Zero
                    CR30 = Zero
                    EXCG ()
                }

                Method (_CRS, 0, NotSerialized)  // _CRS: Current Resource Settings
                {
                    Name (C3CR, Zero)
                    Name (BUF0, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x03E8,             // Range Minimum
                            0x03E8,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            _Y04)
                        IRQ (Edge, ActiveHigh, Exclusive, _Y05)
                            {4}
                    })
                    CreateByteField (BUF0, \_SB.PCI0.LPCB.SIOX.UAR3._CRS._Y04._MIN, IOLO)  // _MIN: Minimum Base Address
                    CreateByteField (BUF0, 0x03, IOHI)
                    CreateByteField (BUF0, \_SB.PCI0.LPCB.SIOX.UAR3._CRS._Y04._MAX, IORL)  // _MAX: Maximum Base Address
                    CreateByteField (BUF0, 0x05, IORH)
                    CreateWordField (BUF0, \_SB.PCI0.LPCB.SIOX.UAR3._CRS._Y05._INT, IRQL)  // _INT: Interrupts
                    ENCG ()
                    CR07 = 0x08
                    IOLO = CR61 /* \_SB_.PCI0.LPCB.SIOX.CR61 */
                    IORL = CR61 /* \_SB_.PCI0.LPCB.SIOX.CR61 */
                    IOHI = CR60 /* \_SB_.PCI0.LPCB.SIOX.CR60 */
                    IORH = CR60 /* \_SB_.PCI0.LPCB.SIOX.CR60 */
                    Local0 = One
                    IRQL = (Local0 << CR70) /* \_SB_.PCI0.LPCB.SIOX.CR70 */
                    EXCG ()
                    Return (BUF0) /* \_SB_.PCI0.LPCB.SIOX.UAR3._CRS.BUF0 */
                }

                Method (_PRS, 0, NotSerialized)  // _PRS: Possible Resource Settings
                {
                }

                Method (_SRS, 1, NotSerialized)  // _SRS: Set Resource Settings
                {
                    CreateByteField (Arg0, 0x02, IOLO)
                    CreateByteField (Arg0, 0x03, IOHI)
                    CreateWordField (Arg0, 0x09, IRQL)
                    ENCG ()
                    CR07 = 0x08
                    CR61 = IOLO /* \_SB_.PCI0.LPCB.SIOX.UAR3._SRS.IOLO */
                    CR60 = IOHI /* \_SB_.PCI0.LPCB.SIOX.UAR3._SRS.IOHI */
                    FindSetRightBit (IRQL, CR70) /* \_SB_.PCI0.LPCB.SIOX.CR70 */
                    If ((IRQL != Zero))
                    {
                        CR70--
                    }

                    CR30 = One
                    If ((CLDN == One))
                    {
                        CRF0 = 0x06
                    }

                    EXCG ()
                }
            }

            Device (UAR4)
            {
                Name (_HID, EisaId ("PNP0501") /* 16550A-compatible COM Serial Port */)  // _HID: Hardware ID
                Name (_UID, "SModuleC4")  // _UID: Unique ID
                Name (_DDN, "COM4      ")  // _DDN: DOS Device Name
                Method (_STA, 0, NotSerialized)  // _STA: Status
                {
                    ENCG ()
                    CR07 = 0x09
                    Local0 = Zero
                    If (DDVC)
                    {
                        Local0 = 0x0D
                        If (CR30)
                        {
                            Local0 = 0x0F
                        }
                    }

                    EXCG ()
                    Return (Local0)
                }

                Method (_DIS, 0, NotSerialized)  // _DIS: Disable Device
                {
                    ENCG ()
                    CR07 = 0x09
                    CRF0 = Zero
                    CR30 = Zero
                    EXCG ()
                }

                Method (_CRS, 0, NotSerialized)  // _CRS: Current Resource Settings
                {
                    Name (C4CR, Zero)
                    Name (BUF0, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x02E8,             // Range Minimum
                            0x02E8,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            _Y06)
                        IRQ (Edge, ActiveHigh, Exclusive, _Y07)
                            {10}
                    })
                    CreateByteField (BUF0, \_SB.PCI0.LPCB.SIOX.UAR4._CRS._Y06._MIN, IOLO)  // _MIN: Minimum Base Address
                    CreateByteField (BUF0, 0x03, IOHI)
                    CreateByteField (BUF0, \_SB.PCI0.LPCB.SIOX.UAR4._CRS._Y06._MAX, IORL)  // _MAX: Maximum Base Address
                    CreateByteField (BUF0, 0x05, IORH)
                    CreateWordField (BUF0, \_SB.PCI0.LPCB.SIOX.UAR4._CRS._Y07._INT, IRQL)  // _INT: Interrupts
                    ENCG ()
                    CR07 = 0x09
                    IOLO = CR61 /* \_SB_.PCI0.LPCB.SIOX.CR61 */
                    IORL = CR61 /* \_SB_.PCI0.LPCB.SIOX.CR61 */
                    IOHI = CR60 /* \_SB_.PCI0.LPCB.SIOX.CR60 */
                    IORH = CR60 /* \_SB_.PCI0.LPCB.SIOX.CR60 */
                    Local0 = One
                    IRQL = (Local0 << CR70) /* \_SB_.PCI0.LPCB.SIOX.CR70 */
                    EXCG ()
                    Return (BUF0) /* \_SB_.PCI0.LPCB.SIOX.UAR4._CRS.BUF0 */
                }

                Method (_PRS, 0, NotSerialized)  // _PRS: Possible Resource Settings
                {
                }

                Method (_SRS, 1, NotSerialized)  // _SRS: Set Resource Settings
                {
                    CreateByteField (Arg0, 0x02, IOLO)
                    CreateByteField (Arg0, 0x03, IOHI)
                    CreateWordField (Arg0, 0x09, IRQL)
                    ENCG ()
                    CR07 = 0x09
                    CR61 = IOLO /* \_SB_.PCI0.LPCB.SIOX.UAR4._SRS.IOLO */
                    CR60 = IOHI /* \_SB_.PCI0.LPCB.SIOX.UAR4._SRS.IOHI */
                    FindSetRightBit (IRQL, CR70) /* \_SB_.PCI0.LPCB.SIOX.CR70 */
                    If ((IRQL != Zero))
                    {
                        CR70--
                    }

                    CR30 = One
                    If ((DLDN == One))
                    {
                        CRF0 = 0x06
                    }

                    EXCG ()
                }
            }

            Device (UAR5)
            {
                Name (_HID, EisaId ("PNP0501") /* 16550A-compatible COM Serial Port */)  // _HID: Hardware ID
                Name (_UID, "SModuleC5")  // _UID: Unique ID
                Name (_DDN, "COM5      ")  // _DDN: DOS Device Name
                Method (_STA, 0, NotSerialized)  // _STA: Status
                {
                    ENCG ()
                    CR07 = 0x0B
                    Local0 = Zero
                    If (EDVC)
                    {
                        Local0 = 0x0D
                        If (CR30)
                        {
                            Local0 = 0x0F
                        }
                    }

                    EXCG ()
                    Return (Local0)
                }

                Method (_DIS, 0, NotSerialized)  // _DIS: Disable Device
                {
                    ENCG ()
                    CR07 = 0x0B
                    CRF0 = Zero
                    CR30 = Zero
                    EXCG ()
                }

                Method (_CRS, 0, NotSerialized)  // _CRS: Current Resource Settings
                {
                    Name (C5CR, Zero)
                    Name (BUF0, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x0368,             // Range Minimum
                            0x0368,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            _Y08)
                        IRQ (Edge, ActiveHigh, Exclusive, _Y09)
                            {6}
                    })
                    CreateByteField (BUF0, \_SB.PCI0.LPCB.SIOX.UAR5._CRS._Y08._MIN, IOLO)  // _MIN: Minimum Base Address
                    CreateByteField (BUF0, 0x03, IOHI)
                    CreateByteField (BUF0, \_SB.PCI0.LPCB.SIOX.UAR5._CRS._Y08._MAX, IORL)  // _MAX: Maximum Base Address
                    CreateByteField (BUF0, 0x05, IORH)
                    CreateWordField (BUF0, \_SB.PCI0.LPCB.SIOX.UAR5._CRS._Y09._INT, IRQL)  // _INT: Interrupts
                    ENCG ()
                    CR07 = 0x0B
                    IOLO = CR61 /* \_SB_.PCI0.LPCB.SIOX.CR61 */
                    IORL = CR61 /* \_SB_.PCI0.LPCB.SIOX.CR61 */
                    IOHI = CR60 /* \_SB_.PCI0.LPCB.SIOX.CR60 */
                    IORH = CR60 /* \_SB_.PCI0.LPCB.SIOX.CR60 */
                    Local0 = One
                    IRQL = (Local0 << CR70) /* \_SB_.PCI0.LPCB.SIOX.CR70 */
                    EXCG ()
                    Return (BUF0) /* \_SB_.PCI0.LPCB.SIOX.UAR5._CRS.BUF0 */
                }

                Method (_PRS, 0, NotSerialized)  // _PRS: Possible Resource Settings
                {
                }

                Method (_SRS, 1, NotSerialized)  // _SRS: Set Resource Settings
                {
                    CreateByteField (Arg0, 0x02, IOLO)
                    CreateByteField (Arg0, 0x03, IOHI)
                    CreateWordField (Arg0, 0x09, IRQL)
                    ENCG ()
                    CR07 = 0x0B
                    CR61 = IOLO /* \_SB_.PCI0.LPCB.SIOX.UAR5._SRS.IOLO */
                    CR60 = IOHI /* \_SB_.PCI0.LPCB.SIOX.UAR5._SRS.IOHI */
                    FindSetRightBit (IRQL, CR70) /* \_SB_.PCI0.LPCB.SIOX.CR70 */
                    If ((IRQL != Zero))
                    {
                        CR70--
                    }

                    CR30 = One
                    If ((ELDN == One))
                    {
                        CRF0 = 0x06
                    }

                    EXCG ()
                }
            }

            Device (UAR6)
            {
                Name (_HID, EisaId ("PNP0501") /* 16550A-compatible COM Serial Port */)  // _HID: Hardware ID
                Name (_UID, "SModuleC6")  // _UID: Unique ID
                Name (_DDN, "COM6      ")  // _DDN: DOS Device Name
                Method (_STA, 0, NotSerialized)  // _STA: Status
                {
                    ENCG ()
                    CR07 = 0x0C
                    Local0 = Zero
                    If (FDVC)
                    {
                        Local0 = 0x0D
                        If (CR30)
                        {
                            Local0 = 0x0F
                        }
                    }

                    EXCG ()
                    Return (Local0)
                }

                Method (_DIS, 0, NotSerialized)  // _DIS: Disable Device
                {
                    ENCG ()
                    CR07 = 0x0C
                    CR30 = Zero
                    EXCG ()
                }

                Method (_CRS, 0, NotSerialized)  // _CRS: Current Resource Settings
                {
                    Name (C6CR, Zero)
                    Name (BUF0, ResourceTemplate ()
                    {
                        IO (Decode16,
                            0x02E0,             // Range Minimum
                            0x02E0,             // Range Maximum
                            0x08,               // Alignment
                            0x08,               // Length
                            _Y0A)
                        IRQ (Edge, ActiveHigh, Exclusive, _Y0B)
                            {7}
                    })
                    CreateByteField (BUF0, \_SB.PCI0.LPCB.SIOX.UAR6._CRS._Y0A._MIN, IOLO)  // _MIN: Minimum Base Address
                    CreateByteField (BUF0, 0x03, IOHI)
                    CreateByteField (BUF0, \_SB.PCI0.LPCB.SIOX.UAR6._CRS._Y0A._MAX, IORL)  // _MAX: Maximum Base Address
                    CreateByteField (BUF0, 0x05, IORH)
                    CreateWordField (BUF0, \_SB.PCI0.LPCB.SIOX.UAR6._CRS._Y0B._INT, IRQL)  // _INT: Interrupts
                    ENCG ()
                    CR07 = 0x0C
                    IOLO = CR61 /* \_SB_.PCI0.LPCB.SIOX.CR61 */
                    IORL = CR61 /* \_SB_.PCI0.LPCB.SIOX.CR61 */
                    IOHI = CR60 /* \_SB_.PCI0.LPCB.SIOX.CR60 */
                    IORH = CR60 /* \_SB_.PCI0.LPCB.SIOX.CR60 */
                    Local0 = One
                    IRQL = (Local0 << CR70) /* \_SB_.PCI0.LPCB.SIOX.CR70 */
                    EXCG ()
                    Return (BUF0) /* \_SB_.PCI0.LPCB.SIOX.UAR6._CRS.BUF0 */
                }

                Method (_PRS, 0, NotSerialized)  // _PRS: Possible Resource Settings
                {
                }

                Method (_SRS, 1, NotSerialized)  // _SRS: Set Resource Settings
                {
                    CreateByteField (Arg0, 0x02, IOLO)
                    CreateByteField (Arg0, 0x03, IOHI)
                    CreateWordField (Arg0, 0x09, IRQL)
                    ENCG ()
                    CR07 = 0x0C
                    CR61 = IOLO /* \_SB_.PCI0.LPCB.SIOX.UAR6._SRS.IOLO */
                    CR60 = IOHI /* \_SB_.PCI0.LPCB.SIOX.UAR6._SRS.IOHI */
                    FindSetRightBit (IRQL, CR70) /* \_SB_.PCI0.LPCB.SIOX.CR70 */
                    If ((IRQL != Zero))
                    {
                        CR70--
                    }

                    CR30 = One
                    EXCG ()
                }
            }

            Device (PS2K)
            {
                Name (_HID, EisaId ("PNP0303") /* IBM Enhanced Keyboard (101/102-key, PS/2 Mouse) */)  // _HID: Hardware ID
                Name (_CID, EisaId ("PNP030B"))  // _CID: Compatible ID
                Name (_UID, "SModuleK")  // _UID: Unique ID
                Method (_STA, 0, NotSerialized)  // _STA: Status
                {
                    If (IDVC)
                    {
                        Return (0x0F)
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }

                Name (_CRS, ResourceTemplate ()  // _CRS: Current Resource Settings
                {
                    IO (Decode16,
                        0x0060,             // Range Minimum
                        0x0060,             // Range Maximum
                        0x01,               // Alignment
                        0x01,               // Length
                        )
                    IO (Decode16,
                        0x0064,             // Range Minimum
                        0x0064,             // Range Maximum
                        0x01,               // Alignment
                        0x01,               // Length
                        )
                    IRQNoFlags ()
                        {1}
                })
            }

            Device (PS2M)
            {
                Name (_HID, EisaId ("PNP0F03") /* Microsoft PS/2-style Mouse */)  // _HID: Hardware ID
                Name (_CID, EisaId ("PNP0F13") /* PS/2 Mouse */)  // _CID: Compatible ID
                Name (_UID, "SModuleM")  // _UID: Unique ID
                Method (_STA, 0, NotSerialized)  // _STA: Status
                {
                    If (JDVC)
                    {
                        Return (0x0F)
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }

                Name (_CRS, ResourceTemplate ()  // _CRS: Current Resource Settings
                {
                    IO (Decode16,
                        0x0060,             // Range Minimum
                        0x0060,             // Range Maximum
                        0x01,               // Alignment
                        0x01,               // Length
                        )
                    IO (Decode16,
                        0x0064,             // Range Minimum
                        0x0064,             // Range Maximum
                        0x01,               // Alignment
                        0x01,               // Length
                        )
                    IRQNoFlags ()
                        {12}
                })
            }
        }
    }
}

